<?php
//
// 画像 クラス
//

class picture {

	/*
	 機能 ファイルのコピー/リサイズ
	 引数 $srcfile コピー元ファイル
	      $dstfile コピー先ファイル
	 戻値 結果（true:成功 false:失敗）
	*/
	function copyresize($srcfile, $dstfile, $option=array()) {
		//オプション既定値
		$option = array_merge(array("width"=>400, "height"=>400), $option);

		list($srcX, $srcY, $imagetype, $attribute) = getimagesize($srcfile);
		//リサイズまたはコピー
		if (in_array($imagetype, array(IMAGETYPE_GIF, IMAGETYPE_JPEG, IMAGETYPE_PNG)) 
			and ($srcX > $option['width'] or $srcY > $option['height']) )
		{	//リサイズ
			//縦横サイズ調整
			$dstX = $srcX;
			$dstY = $srcY;
			if ($dstX > $option['width']) {
				$dstY = $dstY * $option['width'] / $dstX;
				$dstX = $option['width'];
			}
			if ($dstY > $option['height']) {
				$dstX = $dstX * $option['height'] / $dstY;
				$dstY = $option['height'];
			}
			//出力画像生成
			$dst_im = ImageCreateTrueColor($dstX, $dstY);
			//画像取込
			if ($imagetype==IMAGETYPE_GIF)
				$src_im = ImageCreateFromGIF($srcfile);
			elseif ($imagetype==IMAGETYPE_JPEG)
				$src_im = ImageCreateFromJPEG($srcfile);
			elseif($imagetype==IMAGETYPE_PNG)
				$src_im = ImageCreateFromPNG($srcfile);
			//画像サイズ調整
			ImageCopyResized($dst_im, $src_im, 0, 0, 0, 0, $dstX, $dstY, $srcX, $srcY);
			//画像出力
			if ($imagetype==IMAGETYPE_GIF)
				$ret = ImageGIF($dst_im, $dstfile);
			elseif ($imagetype==IMAGETYPE_JPEG)
				$ret = ImageJPEG($dst_im, $dstfile, 100); //品質値を78から100に変更 2007-04-06
			elseif($imagetype==IMAGETYPE_PNG)
				$ret = ImagePNG($dst_im, $dstfile);
			//画像解放
			ImageDestroy($src_im);
			ImageDestroy($dst_im);

		} else {
			//コピー
			$ret = copy($srcfile, $dstfile);
		}

		//ファイルのアクセス権設定
		if ($ret)
			chmod($dstfile, 0777);

		return $ret;
	}


	/*
	 機能 使用されていない画像の削除
	 引数 $dir ディレクトリ
	 	  $content 本文
	 	  $using 必要なファイル
	 戻値 なし
	*/
	function removeNotUsedFiles($dir, $content, $using=array()) {

		//本文から利用中の画像ファイルを取得する
		$pattern = '/<img.*?src="(.*?)".*?>/is';
		preg_match_all($pattern, $content, $matches);
		$pictures = $matches[1];

		//お知らせのファイル一覧
		$files = scandir($dir);

		//必要ファイルを削除対象から除く
		$list = array_merge(array(".", ".."), $pictures, $using);
		foreach ($list as $val) {
			$key = array_search(basename($val), $files);
			if ($key!==false)
				unset($files[$key]);
		}

		//不要ファイルの削除
		foreach ($files as $val) {
			$val = $dir."/".$val;
			if (is_file($val))
				unlink($val);
		}

	}


	/*
	 機能 <img src="">の補正
	 引数 $dirfrom エディタ入力時の画像ディレクトリ
	      $dirto HTML保存後の画像ディレクトリ
	 	  $content 本文
	 戻値 補正した本文HTML
	*/
	function adjustImgUrl($dirfrom, $dirto, $content) {
		//内容の<img>のURLを補正する
		$pattern = '/(\<img.*?src=")('.preg_quote($dirfrom,'/').')(.*?\>)/ise';
		$replacement = '"$1'.$dirto.'$3"';
		$content = preg_replace($pattern, $replacement, $content);
		return $content;
	}


} //クラスの終わり
?>
